#include "main.h"

#include "string.h"

#include "DeviceConfig.h"
#include "STM32_SPI.h"
#include "W5500.h"


volatile struct W5500_NETWORK W5500_Network;




void W5500_NetworkInit(unsigned char *ip,unsigned char *sub,unsigned char *gate,unsigned char *mac)
{

	//Ip Address
	W5500_Network.m_ucIp[0] = *ip;
	ip++;
	W5500_Network.m_ucIp[1] = *ip;
	ip++;
	W5500_Network.m_ucIp[2] = *ip;
	ip++;
	W5500_Network.m_ucIp[3] = *ip;

	W5500_Network.m_ucSubnetMask[0] = *sub;
	sub++;
	W5500_Network.m_ucSubnetMask[1] = *sub;
	sub++;
	W5500_Network.m_ucSubnetMask[2] = *sub;
	sub++;
	W5500_Network.m_ucSubnetMask[3] = *sub;

	W5500_Network.m_ucGateway[0] = *gate;
	gate++;
	W5500_Network.m_ucGateway[1] = *gate;
	gate++;
	W5500_Network.m_ucGateway[2] = *gate;
	gate++;
	W5500_Network.m_ucGateway[3] = *gate;

	W5500_Network.m_ucMAC[0] = *mac;
	mac++;
	W5500_Network.m_ucMAC[1] = *mac;
	mac++;
	W5500_Network.m_ucMAC[2] = *mac;
	mac++;
	W5500_Network.m_ucMAC[3] = *mac;
	mac++;
	W5500_Network.m_ucMAC[4] = *mac;
	mac++;
	W5500_Network.m_ucMAC[5] = *mac;

}


unsigned char W5500_SetIp(unsigned char *buffer)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;


	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_IP_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_IP_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = *buffer;								//SOURCE_IP_ADDRESS_0;
	buffer++;
	W5500_TxDataBuf[4] = *buffer;								//SOURCE_IP_ADDRESS_1;
	buffer++;
	W5500_TxDataBuf[5] = *buffer;								//SOURCE_IP_ADDRESS_2;
	buffer++;
	W5500_TxDataBuf[6] = *buffer;								//SOURCE_IP_ADDRESS_3;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],7);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);

}
unsigned char W5500_GetIp(unsigned char *buffer)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;


	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_IP_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_IP_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read


	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);
	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],4);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*buffer = W5500_RxDataBuf[0];

			buffer++;
			*buffer = W5500_RxDataBuf[1];

			buffer++;
			*buffer = W5500_RxDataBuf[2];

			buffer++;
			*buffer = W5500_RxDataBuf[3];

		}

	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}


unsigned char W5500_SetGateway(unsigned char *buffer)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_GATEWAY_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_GATEWAY_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = *buffer;								//SOURCE_IP_ADDRESS_0;
	buffer++;
	W5500_TxDataBuf[4] = *buffer;								//SOURCE_IP_ADDRESS_1;
	buffer++;
	W5500_TxDataBuf[5] = *buffer;								//SOURCE_IP_ADDRESS_2;
	buffer++;
	W5500_TxDataBuf[6] = *buffer;								//SOURCE_IP_ADDRESS_3;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],7);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);

}
unsigned char W5500_GetGateway(unsigned char *buffer)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_GATEWAY_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_GATEWAY_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],4);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*buffer = W5500_RxDataBuf[0];
			buffer++;
			*buffer = W5500_RxDataBuf[1];

			buffer++;
			*buffer = W5500_RxDataBuf[2];

			buffer++;
			*buffer = W5500_RxDataBuf[3];

		}

	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}



unsigned char W5500_SetSubnetMask(unsigned char *buffer)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_SUBNET_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_SUBNET_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = *buffer;								//SOURCE_IP_ADDRESS_0;
	buffer++;
	W5500_TxDataBuf[4] = *buffer;								//SOURCE_IP_ADDRESS_1;
	buffer++;
	W5500_TxDataBuf[5] = *buffer;								//SOURCE_IP_ADDRESS_2;
	buffer++;
	W5500_TxDataBuf[6] = *buffer;								//SOURCE_IP_ADDRESS_3;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],7);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);

}
unsigned char W5500_GetSubnetMask(unsigned char *buffer)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_SUBNET_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_SUBNET_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],4);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*buffer = W5500_RxDataBuf[0];
			buffer++;
			*buffer = W5500_RxDataBuf[1];

			buffer++;
			*buffer = W5500_RxDataBuf[2];

			buffer++;
			*buffer = W5500_RxDataBuf[3];

		}

	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_SetMac(unsigned char *buffer)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_MAC_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_MAC_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = *buffer;								//SOURCE_IP_ADDRESS_0;
	buffer++;
	W5500_TxDataBuf[4] = *buffer;								//SOURCE_IP_ADDRESS_1;
	buffer++;
	W5500_TxDataBuf[5] = *buffer;								//SOURCE_IP_ADDRESS_2;
	buffer++;
	W5500_TxDataBuf[6] = *buffer;								//SOURCE_IP_ADDRESS_3;

	buffer++;
	W5500_TxDataBuf[7] = *buffer;

	buffer++;
	W5500_TxDataBuf[8] = *buffer;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],9);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);

}


unsigned char W5500_GetMac(unsigned char *buffer)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_MAC_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_MAC_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],6);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*buffer = W5500_RxDataBuf[0];

			buffer++;
			*buffer = W5500_RxDataBuf[1];

			buffer++;
			*buffer = W5500_RxDataBuf[2];

			buffer++;
			*buffer = W5500_RxDataBuf[3];

			buffer++;
			*buffer = W5500_RxDataBuf[4];

			buffer++;
			*buffer = W5500_RxDataBuf[5];

		}

	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_SetNetwork(volatile struct W5500_NETWORK *network)
{
	unsigned char W5500_TxDataBuf[25];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_GATEWAY_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_GATEWAY_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = network->m_ucGateway[0];
	W5500_TxDataBuf[4] = network->m_ucGateway[1];
	W5500_TxDataBuf[5] = network->m_ucGateway[2];
	W5500_TxDataBuf[6] = network->m_ucGateway[3];

	W5500_TxDataBuf[7] = network->m_ucSubnetMask[0];
	W5500_TxDataBuf[8] = network->m_ucSubnetMask[1];
	W5500_TxDataBuf[9] = network->m_ucSubnetMask[2];
	W5500_TxDataBuf[10] = network->m_ucSubnetMask[3];

	W5500_TxDataBuf[11] = network->m_ucMAC[0];
	W5500_TxDataBuf[12] = network->m_ucMAC[1];
	W5500_TxDataBuf[13] = network->m_ucMAC[2];
	W5500_TxDataBuf[14] = network->m_ucMAC[3];
	W5500_TxDataBuf[15] = network->m_ucMAC[4];
	W5500_TxDataBuf[16] = network->m_ucMAC[5];

	W5500_TxDataBuf[17] = network->m_ucIp[0];					//SOURCE_IP_ADDRESS_0;
	W5500_TxDataBuf[18] = network->m_ucIp[1];					//SOURCE_IP_ADDRESS_1;
	W5500_TxDataBuf[19] = network->m_ucIp[2];					//SOURCE_IP_ADDRESS_2;
	W5500_TxDataBuf[20] = network->m_ucIp[3];					//SOURCE_IP_ADDRESS_3;


	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],21);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);

}
unsigned char W5500_GetNetwork(volatile struct W5500_NETWORK *network)
{
	unsigned char W5500_TxDataBuf[5];
	unsigned char W5500_RxDataBuf[20];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_GATEWAY_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_GATEWAY_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],18);
		if(u8ret == W5500_OPERATION_PASS)
		{
			network->m_ucGateway[0] = W5500_RxDataBuf[0];
			network->m_ucGateway[1] = W5500_RxDataBuf[1];
			network->m_ucGateway[2] = W5500_RxDataBuf[2];
			network->m_ucGateway[3] = W5500_RxDataBuf[3];

			network->m_ucSubnetMask[0] = W5500_RxDataBuf[4];
			network->m_ucSubnetMask[1] = W5500_RxDataBuf[5];
			network->m_ucSubnetMask[2] = W5500_RxDataBuf[6];
			network->m_ucSubnetMask[3] = W5500_RxDataBuf[7];

			network->m_ucMAC[0] = W5500_RxDataBuf[8];
			network->m_ucMAC[1] = W5500_RxDataBuf[9];
			network->m_ucMAC[2] = W5500_RxDataBuf[10];
			network->m_ucMAC[3] = W5500_RxDataBuf[11];
			network->m_ucMAC[4] = W5500_RxDataBuf[12];
			network->m_ucMAC[5] = W5500_RxDataBuf[13];

			network->m_ucIp[0] =  W5500_RxDataBuf[14];
			network->m_ucIp[1] =  W5500_RxDataBuf[15];
			network->m_ucIp[2] =  W5500_RxDataBuf[16];
			network->m_ucIp[3] =  W5500_RxDataBuf[17];


		}

	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}


void W5500_Init(void)
{
	 W5500_CS_PIN_HIGH;
	 W5500_RST_PIN_HIGH;
	 HAL_Delay(500);

	 W5500_RST_PIN_LOW;
	 HAL_Delay(10);
	 W5500_RST_PIN_HIGH;
	 HAL_Delay(100);
}

void W5500_HW_Reset(void)
{
	W5500_RST_PIN_LOW;
	HAL_Delay(10);
	W5500_RST_PIN_HIGH;
	HAL_Delay(100);
}

unsigned char W5500_GetChipVersio(unsigned char *result)
{

	unsigned char W5500_TxDataBuf[5];
	unsigned char W5500_RxDataBuf[5];
	unsigned char u8ret = W5500_OPERATION_FAIL;


	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_VERSION >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_VERSION);
	W5500_TxDataBuf[2] = 0x00;
	W5500_RxDataBuf[0] = 0x00;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);
	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*result = W5500_RxDataBuf[0];
		}

	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_SetMode(unsigned char mode)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_MODE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_MODE_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = mode;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}
unsigned char W5500_GetMode(unsigned char *mode)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_MODE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_MODE_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*mode = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_SetIntTimer(unsigned short time_value)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_INT_TIMER_VALUE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_INT_TIMER_VALUE_ADDRESS);

	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(time_value >> 8);
	W5500_TxDataBuf[4] = (unsigned char)(time_value);

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],5);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}
unsigned char W5500_GetIntTimer(unsigned short *time_value)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_INT_TIMER_VALUE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_INT_TIMER_VALUE_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],2);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*time_value = W5500_RxDataBuf[0];
			*time_value = (*time_value << 8);
			*time_value = *time_value | W5500_RxDataBuf[1];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_SetIntReg(unsigned char int_data)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_INT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_INT_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = int_data;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}

unsigned char W5500_GetIntReg(unsigned char *int_data)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_INT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_INT_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*int_data = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_SetIntMaskReg(unsigned char int_mask)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_INT_MASK_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_INT_MASK_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = int_mask;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}

unsigned char W5500_GetIntMaskReg(unsigned char *int_mask)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_INT_MASK_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_INT_MASK_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*int_mask = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}


unsigned char W5500_SetSockIntReg(unsigned char sockint_reg)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_SOCK_INT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_SOCK_INT_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = sockint_reg;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}
unsigned char W5500_GetSockIntReg(unsigned char *sockint_reg)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_SOCK_INT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_SOCK_INT_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*sockint_reg = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_SetSockIntMaskReg(unsigned char sockint_mask_reg)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_SOCK_INT_MASK_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_SOCK_INT_MASK_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = sockint_mask_reg;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}
unsigned char W5500_GetSockIntMaskReg(unsigned char *sockint_mask_reg)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_SOCK_INT_MASK_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_SOCK_INT_MASK_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*sockint_mask_reg = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_SetReTransmitTime(unsigned short retransmit_time)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_INT_TIMER_RETRANSMIT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_INT_TIMER_RETRANSMIT_ADDRESS);

	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(retransmit_time >> 8);
	W5500_TxDataBuf[4] = (unsigned char)(retransmit_time);

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],5);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}
unsigned char W5500_GetReTransmitTime(unsigned short *retransmit_time)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_INT_TIMER_RETRANSMIT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_INT_TIMER_RETRANSMIT_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

		W5500_CS_PIN_LOW;
		HAL_Delay(10);

		u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

		if(u8ret == W5500_OPERATION_PASS)
		{
			u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],2);
			if(u8ret == W5500_OPERATION_PASS)
			{
				*retransmit_time = W5500_RxDataBuf[0];
				*retransmit_time = (*retransmit_time << 8);
				*retransmit_time = *retransmit_time | W5500_RxDataBuf[1];
			}
		}
		W5500_CS_PIN_HIGH;
		HAL_Delay(10);
		return(u8ret);
}

unsigned char W5500_SetReTransmitCount(unsigned char count)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_RETRANSMIT_COUNT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_RETRANSMIT_COUNT_ADDRESS);
	W5500_TxDataBuf[2] = 0x04; //Write Operation

	W5500_TxDataBuf[3] = count;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);

}
unsigned char W5500_GetReTransmitCount(unsigned char *count)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_RETRANSMIT_COUNT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_RETRANSMIT_COUNT_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*count = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_GetPhyConfig(unsigned char *phy_data)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_CHIP_PHYSICAL_LINK_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_CHIP_PHYSICAL_LINK_ADDRESS);
	W5500_TxDataBuf[2] = 0x00; //Read

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*phy_data = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}


unsigned char W5500_Set_Dest_Ip(unsigned char socket_id,unsigned char *ip)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_DESTINATION_IP_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_DESTINATION_IP_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = *ip;
	ip++;
	W5500_TxDataBuf[4] = *ip;
	ip++;
	W5500_TxDataBuf[5] = *ip;
	ip++;
	W5500_TxDataBuf[6] = *ip;

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],7);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}
unsigned char W5500_Get_Dest_Ip(unsigned char socket_id,unsigned char *ip)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_DESTINATION_IP_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_DESTINATION_IP_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],4);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*ip = W5500_RxDataBuf[0];
			ip++;

			*ip = W5500_RxDataBuf[1];
			ip++;

			*ip = W5500_RxDataBuf[2];
			ip++;

			*ip = W5500_RxDataBuf[3];
		}
	}

	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Set_Dest_Port(unsigned char socket_id,unsigned short dest_port)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_DESTINATION_PORT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_DESTINATION_PORT_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(dest_port >> 8);
	W5500_TxDataBuf[4] = (unsigned char)(dest_port);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],5);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}
unsigned char W5500_Get_Dest_Port(unsigned char socket_id,unsigned short *dest_port)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_DESTINATION_PORT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_DESTINATION_PORT_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],2);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*dest_port = W5500_RxDataBuf[0];
			*dest_port = (unsigned short)(*dest_port << 8);
			*dest_port = (unsigned short)(*dest_port | (W5500_RxDataBuf[1]));
		}
	}

	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}


unsigned char W5500_Get_Tx_FreeSize(unsigned char socket_id,unsigned short *size)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_TX_FREE_SIZE_BUFFER_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_TX_FREE_SIZE_BUFFER_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],2);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*size = W5500_RxDataBuf[0];
			*size = (*size << 8);
			*size = (*size | W5500_RxDataBuf[1]);
		}
	}

	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}
unsigned char W5500_Get_Tx_ReadPointer(unsigned char socket_id,unsigned short *pointer_value)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_TX_READ_POINTER_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_TX_READ_POINTER_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],2);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*pointer_value = W5500_RxDataBuf[0];
			*pointer_value = (*pointer_value << 8);
			*pointer_value = (*pointer_value | W5500_RxDataBuf[1]);
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Set_Tx_WritePointer(unsigned char socket_id,unsigned short data_pointer)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_TX_WRITE_POINTER_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_TX_WRITE_POINTER_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

		W5500_TxDataBuf[3] = (unsigned char)(data_pointer >> 8);
		W5500_TxDataBuf[4] = (unsigned char)(data_pointer);

		W5500_CS_PIN_LOW;

		HAL_Delay(10);

		u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],5);

		HAL_Delay(1);
		W5500_CS_PIN_HIGH;
		HAL_Delay(10);

		return(u8ret);
}
unsigned char W5500_Get_Tx_WritePointer(unsigned char socket_id,unsigned short *data_pointer)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_TX_WRITE_POINTER_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_TX_WRITE_POINTER_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],2);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*data_pointer = W5500_RxDataBuf[0];
			*data_pointer = (*data_pointer << 8);
			*data_pointer = (*data_pointer | W5500_RxDataBuf[1]);
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Get_Rx_Recv_Size(unsigned char socket_id,unsigned short *rec_data_size)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_RX_RECV_SIZE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_RX_RECV_SIZE_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],2);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*rec_data_size = W5500_RxDataBuf[0];
			*rec_data_size = (*rec_data_size << 8);
			*rec_data_size = (*rec_data_size | W5500_RxDataBuf[1]);
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Set_Rx_ReadPointer(unsigned char socket_id,unsigned short read_pointer)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_RX_READ_POINTER_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_RX_READ_POINTER_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(read_pointer >> 8);
	W5500_TxDataBuf[4] = (unsigned char)(read_pointer);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],5);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}
unsigned char W5500_Get_Rx_ReadPointer(unsigned char socket_id,unsigned short *read_pointer)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_RX_READ_POINTER_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_RX_READ_POINTER_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],2);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*read_pointer = W5500_RxDataBuf[0];
			*read_pointer = (*read_pointer << 8);
			*read_pointer = (*read_pointer | W5500_RxDataBuf[1]);
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Get_Rx_WritePointer(unsigned char socket_id,unsigned short *write_pointer)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_RX_WRITE_POINTER_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_RX_WRITE_POINTER_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],2);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*write_pointer = W5500_RxDataBuf[0];
			*write_pointer = (*write_pointer << 8);
			*write_pointer = (*write_pointer | W5500_RxDataBuf[1]);
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_SET_TxBuffer(unsigned char socket_id,unsigned char size)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_TX_MAX_SIZE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_TX_MAX_SIZE_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(size);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);

	return(u8ret);
}

unsigned char W5500_GET_TxBuffer(unsigned char socket_id,unsigned char *size)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_TX_MAX_SIZE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_TX_MAX_SIZE_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*size = W5500_RxDataBuf[0];

		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_SET_RxBuffer(unsigned char socket_id,unsigned char size)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_RX_MAX_SIZE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_RX_MAX_SIZE_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(size);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}
unsigned char W5500_GET_RxBuffer(unsigned char socket_id,unsigned char *size)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_RX_MAX_SIZE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_RX_MAX_SIZE_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*size = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Set_Socket_Mode(unsigned char socket_id,unsigned char mode)
{
//Write operation
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_MODE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_MODE_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(mode);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);

}
unsigned char W5500_Get_Socket_Mode(unsigned char socket_id,unsigned char *mode)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_MODE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_MODE_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*mode = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Set_KeepAlive(unsigned char socket_id,unsigned char time)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_KEEP_ALIVE_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_KEEP_ALIVE_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(time);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Set_IntMask(unsigned char socket_id,unsigned char mask_data)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_INT_MASK_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_INT_MASK_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(mask_data);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}
unsigned char W5500_Get_IntMask(unsigned char socket_id,unsigned char *mask_data)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_INT_MASK_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_INT_MASK_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);

	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*mask_data = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}


unsigned char W5500_Set_CommandReg(unsigned char socket_id,unsigned char cmd)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_COMMAND_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_COMMAND_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(cmd);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Get_CommandReg(unsigned char socket_id,unsigned char *cmd)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_COMMAND_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_COMMAND_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);
	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*cmd = W5500_RxDataBuf[0];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Set_InterruptReg(unsigned char socket_id,unsigned char intr_reg)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_INTERRUPT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_INTERRUPT_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(intr_reg);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],4);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}
unsigned char W5500_Get_InterruptReg(unsigned char socket_id,unsigned char *intr_reg)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_INTERRUPT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_INTERRUPT_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);
	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*intr_reg = W5500_RxDataBuf[0];
		}
	}

	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}
unsigned char W5500_Get_StatusReg(unsigned char socket_id,unsigned char *status_reg)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_STATUS_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_STATUS_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);
	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],1);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*status_reg = W5500_RxDataBuf[0];
		}
	}

	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

unsigned char W5500_Set_SourcePort(unsigned char socket_id,unsigned short s_port)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_SOURCE_PORT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_SOURCE_PORT_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_TxDataBuf[3] = (unsigned char)(s_port >> 8);
	W5500_TxDataBuf[4] = (unsigned char)(s_port);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],5);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}
unsigned char W5500_Get_SourcePort(unsigned char socket_id,unsigned short *s_port)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_SOURCE_PORT_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_SOURCE_PORT_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);
	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],2);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*s_port = W5500_RxDataBuf[0];
			*s_port = (unsigned short)(*s_port << 8);
			*s_port = (unsigned short)(*s_port | W5500_RxDataBuf[1]);
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}
unsigned char W5500_Set_Dest_HW_Addr(unsigned char socket_id,unsigned char *buffer)
{

	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_DEST_HW_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_DEST_HW_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation
	W5500_TxDataBuf[3] = (unsigned char)(*buffer);
	buffer++;

	W5500_TxDataBuf[4] = (unsigned char)(*buffer);
	buffer++;
	W5500_TxDataBuf[5] = (unsigned char)(*buffer);
	buffer++;

	W5500_TxDataBuf[6] = (unsigned char)(*buffer);
	buffer++;

	W5500_TxDataBuf[7] = (unsigned char)(*buffer);
	buffer++;

	W5500_TxDataBuf[8] = (unsigned char)(*buffer);

	W5500_CS_PIN_LOW;

	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],9);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}
unsigned char W5500_Get_Dest_HW_Addr(unsigned char socket_id,unsigned char *buffer)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char W5500_RxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));
	memset(&W5500_RxDataBuf[0],0x00,sizeof(W5500_RxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(OFFSET_SOCKET_DEST_HW_ADDRESS >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(OFFSET_SOCKET_DEST_HW_ADDRESS);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_REGISTER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);
	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(&W5500_RxDataBuf[0],6);
		if(u8ret == W5500_OPERATION_PASS)
		{
			*buffer = W5500_RxDataBuf[0];
			buffer++;
			*buffer = W5500_RxDataBuf[1];
			buffer++;
			*buffer = W5500_RxDataBuf[2];
			buffer++;
			*buffer = W5500_RxDataBuf[3];
			buffer++;
			*buffer = W5500_RxDataBuf[4];
			buffer++;
			*buffer = W5500_RxDataBuf[5];
		}
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}


unsigned char W5500_Write_Data_Tx_Buffer(unsigned char socket_id,unsigned short offset,unsigned char *tx_buffer,unsigned short length)
{
	unsigned char W5500_TxDataBuf[10];
	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(offset >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(offset);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_TX_BUFFER_BASE) | SOCKET_WRITE_OPERATION); //Write Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);
	u8ret = STM32_SPI_Write(tx_buffer,length);

	HAL_Delay(1);
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);

}
unsigned char W5500_Read_Data_Rx_Buffer(unsigned char socket_id,unsigned short offset,unsigned char *rx_buffer,unsigned short length)
{
	unsigned char W5500_TxDataBuf[10];

	unsigned char u8ret = W5500_OPERATION_FAIL;

	memset(&W5500_TxDataBuf[0],0x00,sizeof(W5500_TxDataBuf));

	W5500_TxDataBuf[0] = (unsigned char)(offset >> 8);
	W5500_TxDataBuf[1] = (unsigned char)(offset);

	W5500_TxDataBuf[2] = (((socket_id * 32) + BSB_SOCKET0_RX_BUFFER_BASE) | SOCKET_READ_OPERATION); //Read Operation

	W5500_CS_PIN_LOW;
	HAL_Delay(10);

	u8ret = STM32_SPI_Write(&W5500_TxDataBuf[0],3);
	if(u8ret == W5500_OPERATION_PASS)
	{
		u8ret = STM32_SPI_Read(rx_buffer,length);
	}
	W5500_CS_PIN_HIGH;
	HAL_Delay(10);
	return(u8ret);
}

